package prolog.lib;

import botworld.*;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>grab/2</TT>: Bot x grabs bar y.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: grab_2.java,v 1.5 2000/08/10 12:51:03 peteg Exp $
 */
public class grab_2 extends CompiledPredicate {
    public grab_2() {
    }

    /*
     * arg0 = bot number (ignore).
     * arg1 = bar number.
     */
    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
// 	System.err.println("grab(" + args[0] + ", " + args[1] + ")");

	try {
	    int barid = ((Numeric)args[1]).intValue();

	    ((Bot)p.obj).grab(barid);

	    return true;
	} catch(ClassCastException e) {
	    throw new ArgumentException("move/2: invalid arguments: ", args);
	}
    }
}
