package prolog.lib;

import botworld.*;

import java.util.Enumeration;

import prolog.*;

/**
 * <TT>look/1</TT>: Update the bot's view of the world.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: look_1.java,v 1.8 2000/07/26 03:38:39 peteg Exp $
 */
public class look_1 extends CompiledPredicate {
    public look_1() {
    }

    /*
     * arg0 = bot number (ignore).
     */
    public boolean exec(Term[] args, Prolog p) throws PrologException {
// 	System.err.println("look(" + args[0] + ")");

	try{
	    /* Get rid of old stuff (= abolish/2). */
	    ((DynamicPredicate)p.db.get("bar", 4)).clear();
	    ((DynamicPredicate)p.db.get("bot", 6)).clear();
	    ((DynamicPredicate)p.db.get("onBar", 2)).clear();

	    /* Get a list of the movable objects in the world. */
	    for(Enumeration e = ((Bot)(p.obj)).look();
		e.hasMoreElements(); ) {
		WorldObject wo = (WorldObject)e.nextElement();

		p.db.put(new Clause(wo.getFact(), p));
	    }

	    return true;
	} catch(ClassCastException e) {
	    throw new PrologException("look/1: dynamic predicate problems!\n" + e);
	}
    }
}
