package prolog.lib;

import botworld.*;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>move/2</TT>: Move bot forward the specified distance.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: move_2.java,v 1.5 2000/08/10 12:51:03 peteg Exp $
 */
public class move_2 extends CompiledPredicate {
    public move_2() {
    }

    /*
     * arg0 = bot number (ignore).
     * arg1 = distance.
     */
    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	System.err.println("move(" + args[0] + ", " + args[1] + ")");

	try {
	    float dist = ((Numeric)args[1].getBinding()).floatValue();

	    ((Bot)p.obj).move(dist);

	    return true;
	} catch(ClassCastException e) {
	    throw new ArgumentException("move/2: invalid arguments: ", args);
	}
    }
}
