package prolog.lib;

import botworld.*;

import prolog.*;

/**
 * <TT>say/2</TT>: Make the bot speak.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: say_2.java,v 1.4 2000/07/22 12:24:34 peteg Exp $
 */
public class say_2 extends CompiledPredicate {
    public say_2() {
    }

    /*
     * arg0 = bot number (ignore).
     * arg1 = speech.
     */
    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
// 	System.err.println("say: " + args[0] + ", " + args[1] + ")");

	try {
	    Compound arg1 = (Compound)args[1].getBinding();
	    String speech = arg1.functor;

	    ((Bot)p.obj).say(speech);

	    return true;
	} catch(ClassCastException e) {
	    throw new ArgumentException("say/2: invalid arguments: ", args);
	}
    }
}
