package prolog.lib;

import botworld.*;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>turn/2</TT>: Rotate the bot x degrees.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: turn_2.java,v 1.5 2000/08/10 12:51:03 peteg Exp $
 */
public class turn_2 extends CompiledPredicate {
    public turn_2() {
    }

    /*
     * arg0 = bot number (ignore).
     * arg1 = angle (degrees).
     */
    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
// 	System.err.println("turn(" + args[0] + ", " + args[1] + ")");

	try {
	    double angle = ((Numeric)args[1].getBinding()).doubleValue();

	    ((Bot)p.obj).turn(angle);

	    return true;
	} catch(ClassCastException e) {
	    throw new ArgumentException("turn/2: invalid arguments: ", args);
	}
    }
}
