package glog;

import prolog.Compound;

/**
 * Represents the bounding box of a sub-image: it's origin (relative to the
 * absolute origin), angle of rotation (clockwise from the "real" x-axis),
 * size, etc.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: GLogContext.java,v 1.2 2000/06/28 14:19:52 peteg Exp $
 */
public class GLogContext {
    public double width, height,
	angle,
	centreX, centreY;
    public boolean flipped;

    public Compound operation;

    public GLogContext(double w, double h,
		       double a,
		       double x, double y,
		       boolean f,
		       Compound c) {
	width = w;
	height = h;
	angle = a;
	centreX = x;
	centreY = y;

	flipped = f;

	operation = c;
    }

    public GLogContext(GLogContext gc, Compound c) {
	this(gc.width, gc.height,
	     gc.angle,
	     gc.centreX, gc.centreY,
	     gc.flipped,
	     c);
    }

    public String toString() {
	StringBuffer sb = new StringBuffer();

	sb.append("w = ");
	sb.append(width);
	sb.append(", h = ");
	sb.append(height);
	sb.append(", a = ");
	sb.append(angle);
	sb.append(", x = ");
	sb.append(centreX);
	sb.append(", y = ");
	sb.append(centreY);
	sb.append(", f = ");
	sb.append(flipped);
	sb.append("\n op = ");
	sb.append(operation);

	return(sb.toString());
    }
}
