package prolog;

/**
 * Trailing for type variables.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: TypeTrail.java,v 1.1 2000/11/12 12:22:45 peteg Exp $
 * @see prolog.TermInfo
 */
public class TypeTrail {
    TermInfo trail;

    TypeTrail() {
    }

    /**
     * Unwinds the trail, after an attempted type unification.
     */
    void unwind() {
	while(trail != null) {
 	    ((TypeVariable)trail.type).unbind(trail);
	    trail = trail.next;
	}
    }

    public String toString() {
	return trail.toString();
    }
}
