package prolog.lib;

import prolog.*;

/**
 * <TT>'!'/0</TT>: the cut. This is the unifier which actually prunes the stack.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: _cut_0.java,v 1.14 2000/11/12 12:22:45 peteg Exp $
 * @see prolog.Prolog#cut
 */
public class _cut_0 extends CompiledPredicate {
    /**
     * The cut <TT>Compound</TT> object. This can be shared as there is no
     * state involved.
     */
    public static final Compound cut = new Compound("_cut");

    public _cut_0() {
    }

    public boolean exec(Term[] args, Prolog p) {
//   	System.err.println("Executing: !/0.");

	p.cut();

	return true;
    }

    public boolean compile_call(ClauseCodeGen ccg, Term[] args, boolean lastcall) {
	


	return true;

//  	throw new RuntimeException("_cut_0.compile(): not implemented.");
    }

    public String toString() {
	return "\n!.\n";
    }
}
