package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>_has_type/2</TT>: Defines a predicate to have a specified type.
 * <P>
 * <TT>Predicate/Arity :: Arg1Type, Arg2Type, ...</TT>
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: _has_type_2.java,v 1.3 2000/08/28 13:06:46 peteg Exp $
 * @see prolog.TypeDictionary
 * @see prolog.lib._type_def_2
 * @see prolog.lib.listtypes_0
 */
public class _has_type_2 extends CompiledPredicate {
    public _has_type_2() {
    }

    public boolean exec(Term[] args, Prolog p) throws PrologException {
	try {
	    Compound arg0 = (Compound)args[0];
 	    String f = ((Compound)arg0.args[0]).functor;
 	    int a = ((Numeric)arg0.args[1]).intValue();

	    throw new RuntimeException("_has_type/2: " + args[0] + " -- " + args[1]);

// 	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("::/2: invalid argument: ", args);
	}
    }
}
