package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>arg/3</TT>: Extract the <I>i</I>th argument of a <TT>Compound</TT>
 * term.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: arg_3.java,v 1.1 2000/09/15 15:11:34 peteg Exp $
 */
public class arg_3 extends CompiledPredicate {
    public arg_3() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	try {
	    int      arg0 = ((Numeric)args[0].getBinding()).intValue();
	    Compound arg1 = (Compound)args[1].getBinding();
	    Term     arg2 = args[2];

	    return arg2.unify(arg1.args[arg0 - 1], null, p);
	} catch (ClassCastException e) {
	    throw new ArgumentException("arg/3: invalid arguments: ", args);
	}
    }

    public String toString() {
	return "arg/3";
    }
}
