package prolog.lib;

import prolog.*;
import prolog.math.Numeric;

/**
 * <TT>atom/1</TT>: Is this <TT>Term</TT> an atom? (atom == Num, Compound
 * with arity = 0).
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: atom_1.java,v 1.1 2000/09/15 15:11:34 peteg Exp $
 */
public class atom_1 extends CompiledPredicate {
    public atom_1() {
    }

    public boolean exec(Term[] args, Prolog p) {
	Term arg0 = args[0].getBinding();

	return arg0 instanceof Compound && ((Compound)arg0).arity == 0;
    }
}
