package prolog.lib;

import prolog.*;

/**
 * <TT>builtin/1</TT>: True if the argument is a builtin predicate.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: builtin_1.java,v 1.4 2000/07/22 12:25:01 peteg Exp $
 */
public class builtin_1 extends CompiledPredicate {
    public builtin_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	Compound arg0;

	try {
	    arg0 = (Compound)args[0].getBinding();
	} catch(ClassCastException e) {
	    throw new ArgumentException("builtin/1 invalid argument: ", args);
	}

	Predicate predicate = p.db.get(arg0);

	return predicate != null
	    && predicate instanceof CompiledPredicate;
    }
}
