package prolog.lib;

import prolog.*;

/**
 * <TT>repeat/0</TT>: Create an "infinite" choicepoint.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: repeat_0.java,v 1.6 2000/08/22 12:11:39 peteg Exp $
 */
public class repeat_0 extends Predicate {
    public repeat_0() {
    }

    public boolean unify(Term[] args, Prolog p) {
	p.allocate_cp(null, p.get_trail_top());
	p.use_pending_goal();

	return true;
    }

    public boolean redo(Term[] args, Prolog p, ChoicePoint cp) {
	return unify(args, p);
    }

    public String toString() {
	return "\n(builtin)\nrepeat.\nrepeat :- repeat.\n";
    }
}
