package prolog.lib;

import java.io.*;

import prolog.*;

/**
 * <TT>serialize/1</TT>: Dump the database to the specified file using
 * Java's serialization functions. Useful for applet stuff.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: serialize_1.java,v 1.6 2000/08/02 11:47:55 peteg Exp $
 * @see prolog.Database
 * @see prolog.lib.deserialize_1
 */
public class serialize_1 extends CompiledPredicate {
    public serialize_1() {
    }

    public boolean exec(Term[] args, Prolog p) throws PrologException {
//    	System.err.println("serialize: " + args);

	try {
	    Compound arg0 = (Compound)args[0].getBinding();
	    String filename = arg0.functor;

	    /* Standard technique - straight out of "Java in a Nutshell" */
	    FileOutputStream fos = new FileOutputStream(filename);
	    ObjectOutputStream out = new ObjectOutputStream(fos);

	    out.writeObject(p.db);
	    out.flush();
	    out.close();

	    return true;
	} catch (ClassCastException e) {
	    throw new ArgumentException("serialize/1: invalid argument: ", args);
	} catch (IOException e) {
	    throw new PrologException("serialize/1: IOException: " + e);
	}
    }
}
