package prolog.util;

/**
 * Synchronous queue (not thread safe, no buffering). This is the queue you
 * have when you don't have a queue.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: SyncQueue.java,v 1.2 2000/06/28 14:19:36 peteg Exp $
 */
public class SyncQueue implements Queue {
    QueueConsumer customer;

    public SyncQueue(QueueConsumer qc) {
	customer = qc;
    }

    public void enqueue(Object o) {
	customer.consume(o);
    }

    /**
     * Not implemented.
     */
    public Object dequeue() {
	throw new RuntimeException("SyncQueue.dequeue(): not implemented.");
    }

    /**
     * Not implemented.
     */
    public boolean isEmpty() {
	throw new RuntimeException("SyncQueue.isEmpty(): not implemented.");
    }
}
