package prolog.lib;

import prolog.*;

/* append/3: Concatenate two lists. append(list, list, binding). */
public class append_3 extends CompiledPredicate {
    private static FunctorArity list_cell = Compound.map_functor_arity(".", 2);

    public append_3() {
    }

    public boolean exec(Term[] args, Prolog p) throws ArgumentException {
	Compound arg0 = (Compound)args[0].getBinding();
	Term     arg1 = args[1];
	Binding  arg2 = (Binding)args[2].getBinding();

	Compound new_list_start = null, new_list_end = null;

	while(arg0.functor != Parser.empty_list_functor) {
	    Term[] new_list_args = new Term[2];
	    Compound cell = new Compound(list_cell, new_list_args);

	    new_list_args[0] = arg0.args[0];

	    if(new_list_start == null) {
		new_list_start = new_list_end = cell;
	    } else {
		new_list_end.args[1] = cell;
		new_list_end = cell;
	    }

	    arg0 = (Compound)arg0.args[1].getBinding();
	}

	if(new_list_end != null) {
	    new_list_end.args[1] = arg1;
	    p.push(arg2, new_list_start);
	} else {
	    p.push(arg2, arg1);
	}

	return true;
    }
}
