 
%----------------------------Comp2411 assignment------------------------------------
%Author:Mohit Jotwani--------------
%Tutor:Allen courtney--------------
%Tute:Mon(2-3)----------------------
 
%-----This is the tokenizer given to get the list of tokens---------------------- 
get_tokens(File,L)  :- see(File),
                          tokens(L),
                          seen(File).

tokens(R) :- ratom(A),
                 !,
             (A = end_of_file -> R = [] | R = [A|R1], tokens(R1)).
	     
	      
%-----This is the part where it checks for the variables' syntax----------------- 

 variable([variables|X0],X1,Var) :- checkvarlist(X0,X1,Var).
 
 
 checkvarlist([H,';'|T],T,[H|[]]) :- checkAlpha(H),not(keyword(H)),!.
 checkvarlist([H,','|T],L1,[H|Z]) :- checkAlpha(H),not(keyword(H)),checkvarlist(T,L1,Z).
 
 keyword(begin).
 keyword(if).
 keyword(while).
 keyword(then).
 keyword(else).
 keyword(do).
 keyword(initialcondition).
 keyword(finalcondition).
 keyword(not).
 keyword(variables).

 semicolon([';'|Tail],Tail).
 comma([','|Tail],Tail).

 checkAlpha(X) :- atom_chars(X,[H|T]),char_code(H,A),
                  A >= 97,A =< 122,!.
		  
%-----Checkinitial and final just return back the tokens after the keyword		  

checkinitial([initialcondition|T],T).
checkfinal([finalcondition|T],T). 

%-----Expression converts the formulas to a desired state e.g.isand(_,_)-------- 

expression(X,[X|T],T,Var):- member(X,Var).



expression(isor(F1,F2),R0,R,Var):- R0=['('|R1],expression(F1,R1,R2,Var),
                                R2=['\/'|R3],expression(F2,R3,R4,Var),
                                R4=[')'|R].

expression(isand(F1,F2),R0,R,Var):- R0=['('|R1],expression(F1,R1,R2,Var),
                                R2=['/\'|R3],expression(F2,R3,R4,Var),
                                R4=[')'|R].


expression(isimply(F1,F2),R0,R,Var):- R0=['('|R1],expression(F1,R1,R2,Var),
                                R2=['->'|R3],expression(F2,R3,R4,Var),
                                R4=[')'|R].



expression(isnot(F1),R0,R,Var):- R0=[not,'('|R1],expression(F1,R1,R2,Var),
                                R2=[')'|R].

%------Statement parses the statements of the program body-------

statement([begin|Y],S2,Var):-statement(Y,S1,Var),S1=[end|S2],!.



statement([if|Y],S0,Var) :- expression(F,Y,Z,Var),Z=[then|S1],
                            statement(S1,S2,Var),S2=[else|S0],!.			    


statement([while|T],S0,Var):-expression(F,T,T0,Var),T0=[do|S1],
                               statement(S1,S0,Var),!.

statement([H,':='|T],S0,Var):-member(H,Var),expression(F,T,T0,Var),
                              T0=[';',else|S0],!,fail.
statement([H,':='|T],S0,Var):-member(H,Var),expression(F,T,T0,Var),
                              T0=[';',end|S0],!,fail.			      			     

statement([H,':='|T],S0,Var):-member(H,Var),expression(F,T,T0,Var),
                             T0=[';'|S0],!.			      

statement([H,':='|T],S0,Var):- member(H,Var),expression(F,T,T0,Var),
                              T0=[end|_],S0=T0,!.
			       
%-----Program calls statements that calls statement to parse the------------ 

program(X0,X1,Var) :- checkbegin(X0,X2),statements(X2,X3,Var),
                      checkend(X3,X1),!.
statements(X0,X1,Var) :- statement(X0,X2,Var),statements(X2,X1,Var).
statements(X0,X1,Var).

checkbegin([begin|T],T).
checkend([end],[]).

checkdo([H,':='|T],[H,':='|T]).
checkdo([begin|T],[begin|T]).

docheck(X0,X1,Var):-whilestatement(X0,X1,Var).
whilestatement([begin|Y],S2,Var):-statement(Y,S1,Var),S1=[end|S2],!.
whilestatement([H,':='|T],S0,Var):-member(H,Var),expression(F,T,T0,Var),
                              T0=[';',else|S0],!,fail.
whilestatement([H,':='|T],S0,Var):-member(H,Var),expression(F,T,T0,Var),
                              T0=[';',end|S0],!,fail.			      			     

whilestatement([H,':='|T],S0,Var):-member(H,Var),expression(F,T,T0,Var),
                             T0=[';'|S0],!.


%----Output is used to give the output list when needed--------------------

  output(val(X0,X),[val(X0,X)|T],[val(X0,X)|T]).
  output(val(X0,X),[val(X0,Y)|T],[val(X0,X)|T]).
  output(val(X0,X),[H|T],[H|Z]):-output(val(X0,X),T,Z).

%-----evalexp is used to evaluate the expression--------------------------- 

  evalexp(X0,I,Var,O):-getoperand(X0,X),X==isand,getexp(X0,F1,F2),
                   evalexp(F1,I,Var,O1),evalexp(F2,I,Var,O2),
                   giveand(O1,O2,O),!.

  evalexp(X0,I,Var,O):-getoperand(X0,X),X==isor,getexp(X0,F1,F2),
                   evalexp(F1,I,Var,O1),evalexp(F2,I,Var,O2),
                   giveor(O1,O2,O),!.

  evalexp(X0,I,Var,O):-getoperand(X0,X),X==isimply,getexp(X0,F1,F2),
                   evalexp(F1,I,Var,O1),evalexp(F2,I,Var,O2),
                   giveimply(O1,O2,O),!.


  evalexp(X0,I,Var,O):-getnotoperand(X0,X),X==isnot,getnotexp(X0,F),
                       evalexp(F,I,Var,O1),givenot(O1,O),!.

  evalexp(X0,I,Var,O):-member(X0,Var),getvarvalue(X0,I,O),!.

%------Theses are the small predicates that are being used by the evalexp---------
  getoperand(isand(_,_),isand).
  getoperand(isor(_,_),isor).
  getoperand(isimply(_,_),isimply).
  getnotoperand(isnot(_),isnot).

  getvarvalue(X,I,O):-member(val(X,O),I).

  getexp(isand(F1,F2),F1,F2).
  getexp(isor(F1,F2),F1,F2).
  getexp(isimply(F1,F2),F1,F2).
  getnotexp(isnot(F),F).

  giveand(false,_,false).
  giveand(true,false,false).
  giveand(true,true,true).

  giveor(true,_,true).
  giveor(false,true,true).
  giveor(false,false,false).

  giveimply(true,false,false).
  giveimply(true,true,true).
  giveimply(false,_,true). 
                   
  givenot(true,false).
  givenot(false,true).


 getcondition([then|T],[],T).
 getcondition([H|T],[H|Z],L):-getcondition(T,Z,L).
 

 getthen([else|T],[],T).
 getthen([H|T],[H|Z],L):-getthen(T,Z,L).


 getelse([begin|T],[],[begin|T]).
 getelse([if|T],[],[if|T]).
 getelse([end|T],[],[end|T]).
 getelse([while|T],[],[while|T]).
 getelse([H|T],[H|Z],L):-getelse(T,Z,L).



%----This part evaluates the program statements.It is called by the predicate proeval.----------

evaluate([if|T],I,Var,T5,O):-getcondition(T,T0,T1),expression(F,T0,[],Var),
                             evalexp(F,I,Var,O1),getthen(T1,T2,T3),
                             getelse(T3,T4,T5),O1==true,
                             evaluate(T2,I,Var,[],O),!.

evaluate([if|T],I,Var,T5,O):-getcondition(T,T0,T1),expression(F,T0,[],Var),
                             evalexp(F,I,Var,O1),getthen(T1,T2,T3),
                             getelse(T3,T4,T5),O1==false,
                             evaluate(T4,I,Var,[],O),!.

evaluate([begin|T],I,Var,T0,O):-evaluate(T,I,Var,[end|T0],O),!.

evaluate([H,':='|T],I, Var,Rem,O):-expression(F,T,[';'|Rem],Var),
                                  evalexp(F,I,Var,O1),output(val(H,O1),I,O),!.

evaluate([H,':='|T],I, Var,T0,O):-expression(F,T,T0,Var),T0=[end|Rem],
                                  evalexp(F,I,Var,O1),output(val(H,O1),I,O),!.
				  
evaluate([H,':='|T],I, Var,T0,O):-expression(F,T,T0,Var),T0=[else|Rem],
                                  evalexp(F,I,Var,O1),output(val(H,O1),I,O),!.
				  				  

proeval(X,I,Var,X1,O):-checkbegin(X,T),evaluatest(T,I,Var,T0,O),
                       checkend(T0,X1),!.
evaluatest(X,I,Var,X0,O):-evaluate(X,I,Var,X1,O),evaluatest(X1,I,Var,X0,O).
evaluatest(X,I,Var,X0,O).

%------This predicate returns all the possible corresponding truth values for the input list---------
                              
isvalue(true).
isvalue(false).

truth_value([],[]).
truth_value([U|R],[val(U,C)|R1]):-isvalue(C),truth_value(R,R1).

checkoutput(X,Y,X):- X==Y,!.
checkoutput(X,Y,Y).

%-------This is the whole parsing of the file---------------------------------------------------------

parsefile(F,Var,Initial,Final,T5,T6):- get_tokens(F,T),variable(T,T0,Var),
                           checkinitial(T0,X0),
                           expression(Initial,X0,T1,Var),semicolon(T1,T2),
                           checkfinal(T2,T3),expression(Final,T3,T4,Var),
                           semicolon(T4,T5),program(T5,T6,Var),T6==[].

%-------This is the main parse predicate to check for parsing-----------------------------------------

parse(F):-get_tokens(F,T),variable(T,T0,Var),
          checkinitial(T0,X0),
          expression(Initial,X0,T1,Var),semicolon(T1,T2),
          checkfinal(T2,T3),expression(Final,T3,T4,Var),
          semicolon(T4,T5),program(T5,T6,Var),T6==[]. 
%-------The main check predicate called to check the specifications of the program--------------------	    
	    
check(F,I,O):-parsefile(F,Var,Initial,Final,Program,Y),!,truth_value(Var,I),evalexp(Initial,I,Var,O1),
              proeval(Program,I,Var,Y,O),evalexp(Final,O,Var,Result),O1==true,Result==false.
	      
check(_,syntaxerror,syntaxerror).	      
	      
	    
%-----------------------------------------THE END------------------------------------------------------	    
      
