% -*- Prolog -*-
%
% mergesort
%
%  from "The Craft of Prolog" -- Richard A. O'Keefe
%

main :- msort([27, 74, 17, 33, 94, 18, 46, 83, 65, 2, 32, 53, 28, 85, 99,
	47, 28, 82, 6, 11, 55, 29, 39, 81, 90, 37, 10, 0, 66, 51, 7, 21, 85,
	27, 31,	63, 75, 4, 95, 99, 11, 28, 61, 74, 18, 92, 40, 53, 59, 8], X).

%main :- msort([27, 74, 17, 33, 94, 18], X).

msort([], []) :- !.
msort(List, Answer) :-
	list_length(List, Length),
	msort(Length, List, Answer, []).

msort(1, [X|Rest], [X], Rest) :- !.
msort(2, [X,Y|Rest], Answer, Rest) :-
	!,
	sort2(X, Y, Answer).
msort(N, List, Answer, Rest) :-
	is(A, N // 2),	msort(A, List, X, Middle),
	is(Z, N - A),	msort(Z, Middle, Y, Rest),
	merge(X, Y, Answer).

% Glib sort pair predicate -- not robust.

sort2(X, Y, Answer) :-
	le(X, Y),
	!,
	unify(Answer, [X, Y]).
sort2(X, Y, [Y, X]).


merge([H1|T1], [X|L2], [X|M1]) :-
	lt(X, H1),
	!,
	merge([H1|T1], L2, M1).
merge([X|L1], L2, [X|M1]) :-
	!,
	merge(L1, L2, M1).
merge([], L2, L2).


% Support predicates

list_length([], 0) :- !.
list_length([_|Xs], L) :-
	list_length(Xs, L1),
	is(L, L1 + 1).
