% -*- Prolog -*-
%
% Naive reverse.
%
% $Id: nrev.pro,v 1.3 2000/11/12 12:22:46 peteg Exp $

:- list(X) ::= [] ; [X | list(X)].
:- compile(append/3).

% append/3 - concat two lists in order
append([], X, X).
append([X|Xs], Y, [X|Zs]) :-
	append(Xs, Y, Zs).

% nrev/2 - naive reverse
nrev([],[]).
nrev([X|Xs],Zs) :-
	nrev(Xs,Ys),
	append(Ys,[X],Zs).

% nrev 30 has 496 logical inferences
nrev30 :- nrev([1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9,0,1,2,3,4,5,6,7,8,9,0], X).

% Benchmarking
benchmark :-
	benchmark(200).

benchmark(0) :- !.
benchmark(X) :-
	nrev30,
	X0 is X - 1,
	benchmark(X0).
