package prolog;

/* The JavaClass package. */
import de.fub.bytecode.classfile.*;
import de.fub.bytecode.generic.*;

/**
 * Represents the empty list / end-of-list: </TT>[]</TT>, the final element
 * of a closed list.
 *
 * @author Peter Gammie (<A HREF="MailTo:peteg@cse.unsw.edu.au">peteg@cse.unsw.edu.au</A>)
 * @version $Id: EmptyListType.java,v 1.1 2000/08/06 13:43:46 peteg Exp $
 */
class EmptyListType extends ListType {
    public final static EmptyListType type = new EmptyListType();

    private EmptyListType() {
	super();
    }

    public boolean equals(Object o) {
	return(o == this);
    }

    boolean unifiable(TermType t) {
	return(t instanceof EmptyListType);
    }

    boolean compile_unify(TermInfo ti0, Term arg0, Term arg1, InstructionStrand is) {
	throw new RuntimeException("EmptyList.compile_unify()");
    }

    void create(Term t, TermType type, InstructionStrand is) {
	System.err.println("EmptyList.create(): creating.");
	is.list_load_emptyList();
    }

    public String toString() {
	return("L");
    }
}
