% -*- Prolog -*-
%
% Meta interpreter for building a proof tree, using rule/2.
%  from "The Art of Prolog" -- Leon Sterling, Ehud Shapiro, MIT Press.
%

solve([], []).
solve([A|B], [ProofA|ProofB]) :-
	!, solve(A, ProofA), solve(B, ProofB).
solve(A, proof(A, builtin)) :- builtin(A), !, call(A).
solve(A, proof(A, Proof)) :- rule(A, B), solve(B, Proof).

% append/3 - concat two lists in order
append([], X, X).
append([X|Xs], Y, [X|Z]) :- append(Xs, Y, Z).

% nrev/2 - naive reverse
nrev([],[]).
nrev([X|Xs], Zs) :- nrev(Xs, Ys), append(Ys, [X], Zs).

main :-
	solve(nrev([1, 2, 3], X), Proof).
