% -*- Prolog -*-
%
% testing the cut, and other builtins. Really a pile of list
% processing routines.

member(X, [X|Xs]).
member(X, [Y|Ys]) :- member(X, Ys).

% Transformed version (like the compiler would)
%member(X, Z) :- unify(Z, [X|Xs]).
%member(X, Z) :- unify(Z, [Y|Ys]), member(X, Ys).

append([], X, X).
append([X|Xs], Y, [X|Z]) :- append(Xs, Y, Z).

% abi's prolog exercise
remove_duplicates([], []).

remove_duplicates([X|Xs], Y) :-
	member(X, Xs),
	remove_duplicates(Xs, Y).

remove_duplicates([X|Xs], [X|Y]) :-
	not(member(X, Xs)),
	remove_duplicates(Xs, Y).

% Library predicates easier to define in prolog than natively

not(X) :- call(X), !, fail.
not(X).

unify(X, X).

%main :- member(X, [c, a, b, c]), nl, nl, write(X), nl, nl, !, member(X, [b, a]).
%main :- member(X, [c, a, b, c]).
%main :- member(a, X).
%main :- append(X, Y, [a, b, c]).

%main :- append(X, Y, [a, b, c]).
%main :- append([z, y, x, w, v, u, t, s, r, q, p], [a, b, c, d, e, f, g, h, i, j, k], X).

%main :-
%	member(X, [member(Y, [b, a, b]), remove_duplicates([1, 1, 2, 3, 2, 3, 1], L)]),
%	call(X).

% Classic "for" loop in prolog
while :-
	assert(count(1)),
	repeat,
		count(X),
		write("iteration: "), write(X), nl,
		
		retract(count(X)),
		is(X1, X + 1),
		assert(count(X1)),
		gt(X1, 10),
	!,
	retract(count(X)),
	write(done),
	nl.
