% -*- Prolog -*-
%
% Least-general-generalisation.
%
% Pinched from a CS3411 Tutorial Solution.
%

%
% unify/3: Unify two terms together, producing a set of substitutions.
%
unify(T1, T2, S) :-
	unify(T1, T2, [], S).

unify(T1, T2, S0, [s(T1, T2)|S0]) :-	% T1 is a variable, so bind it to T2
	var(T1),
	!,
	write(" T1 = "), write(T1), nl,
	write(" T2 = "), write(T2), nl,
	write(" S0 = "), write(S0), nl.
unify(T1, T2, S0, S) :-		% T2 is a variable, so swap roles of T1, T2
	var(T2),
	!,
	unify(T2, T1, S0, S).
unify([], [], _, _) :-
	!.
unify([H1|T1], [H2|T2], S0, S) :-
	writerr("list"), nl,
	!,
	unify(H1, H2, S0, S1),
	unify(T1, T2, S1, S).
unify(T1, T2, S, S) :-
	writerr("atomic test"), nl,
	atomic(T1),
	!,
	identical(T1, T2).
unify(T1, T2, S0, S) :-
	writerr("pull compound to bits"), nl,
	univ(T1, L1),
	univ(T2, L2),
	unify(L1, L2, S0, S).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Support predicates for a fledgling Prolog.

app(X, [], [X]) :- !.
app(X, Y, [X|Y]).

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% test code.

main :-
	unify(f(a), f(Y), X).
%	unify(f(g(A), B, A), f(g(h(a)), i(b), h(a)), X).
